import os
import scipy.io
import numpy as np
from collections import OrderedDict

import torch.nn as nn
import torch.nn.functional as F
from torch.autograd import Variable
import torch

from matplotlib import pyplot as plt
import sys
sys.path.insert(0,'/home/lpx/Desktop/code-vot2018/VOT2018/vot-toolkit-master/SYT_W/SYT/')
from layers import *
_conv_stride = np.array([2,1,1,1,1])
_filtergroup_yn = np.array([0,1,0,1,1], dtype=bool)
_bnorm_yn = np.array([1,1,1,1,0], dtype=bool)
_relu_yn = np.array([1,1,1,1,0], dtype=bool)
_pool_stride = np.array([2,1,0,0,0]) # 0 means no pool
_pool_sz = 3
_bnorm_adjust = True
assert len(_conv_stride) == len(_filtergroup_yn) == len(_bnorm_yn) == len(_relu_yn) == len(_pool_stride), ('These arrays of flags should have same length')
assert all(_conv_stride) >= True, ('The number of conv layers is assumed to define the depth of the network')
_num_layers = len(_conv_stride)


# class CFConv1Net(nn.Module):
#     def __init__(self, in_num_channels, out_num_channels):
#         super(CFConv1Net, self).__init__()
#         self.in_num_channels = in_num_channels
#         self.out_num_channels = out_num_channels
#         # self.rw = int(np.ceil(target_sz[0] / 2))
#         # self.rh = int(np.ceil(target_sz[1] / 2))
#         # self.fw = int(self.rw * 2 + 1)
#         # self.fh = int(self.rh * 2 + 1)
#         # self.conv1 = nn.Conv2d(self.in_num_channels, self.out_num_channels, kernel_size=1, stride=1, padding=0)
#         self.cf = nn.Conv2d(self.out_num_channels, 1, kernel_size=(17, 17),
#                             stride=1, padding=(self.rh, self.rw))
#         self.weight_init()
#
#     def forward(self, x):
#         x = conv2d(x, weights['conv1.weight'], weights['conv1.bias'], stride=1, padding=0)
#         x0 = conv2d(x, weights['cf.weight'], weights['cf.bias'], stride=1, padding=(self.rh, self.rw))
#         return x0
#
#     def weight_init(self):
#         self.conv1.bias.data.zero_()
#         self.cf.bias.data.zero_()
#         self.conv1.weight.data = (self.conv1.weight.data.normal_() / np.sqrt(self.conv1.in_channels)) / 1e5
#         self.cf.weight.data = (self.cf.weight.data.normal_() / np.sqrt(self.cf.in_channels * self.rh * self.rw)) / 1e5
#         # self.cf1.weight.data = (self.cf1.weight.data.normal_() / np.sqrt(self.cf1.in_channels * self.rh1 * self.rw1)) / 1e5
#         # self.cf2.weight.data = (self.cf2.weight.data.normal_() / np.sqrt(self.cf2.in_channels * self.rh2 * self.rw2)) / 1e5
#
#     def copy_meta_weights(self, meta_weights):
#         for k, p in self.named_parameters():
#             if p.requires_grad and k in meta_weights.keys():
#                 p.data = meta_weights[k].clone()
score_sz2 =264
class FeatureExtractor_siam(nn.Module):
    def __init__(self, model_path=None):
        super(FeatureExtractor_siam, self).__init__()
        if model_path is not None:
            # read mat file from net_path and start TF Siamese graph from placeholders X and Z
            self.params_names_list, self.params_values_list = self._import_from_matconvnet(model_path)
        else:
            self.params_names_list = None
            self.params_values_list = None

        self.conv1 = nn.Conv2d(3, 96, kernel_size=11, stride=2, padding=0)
        self.bn1 = nn.BatchNorm2d(96)
        # self.bn1 = nn.LayerNorm(96)
        self.relu1 = nn.ReLU()
        # self.pad1 = nn.ZeroPad2d((0, 1, 0, 1))
        self.pool1 = nn.MaxPool2d(kernel_size=3, stride=2, padding=0)

        self.conv2 = nn.Conv2d(48, 256, kernel_size=5, stride=1, padding=0)
        self.bn2 = nn.BatchNorm2d(256)
        self.relu2 = nn.ReLU()
        # self.pad2 = nn.ZeroPad2d((0, 1, 0, 1))
        self.pool2 = nn.MaxPool2d(kernel_size=3, stride=1, padding=0)

        self.conv3 = nn.Conv2d(256, 384, kernel_size=3, stride=1, padding=0)
        self.bn3 = nn.BatchNorm2d(384)
        self.relu3 = nn.ReLU()

        self.conv4 = nn.Conv2d(192, 384, kernel_size=3, stride=1, padding=0)
        self.bn4 = nn.BatchNorm2d(384)
        self.relu4 = nn.ReLU()

        self.conv5 = nn.Conv2d(192, 32, kernel_size=3, stride=1, padding=0)
        self.bn55 = nn.BatchNorm2d(32)
        self.bn5 = nn.BatchNorm2d(1)

        self.bn_beta1 = self.get_bn_var('br_bn' + str(1) + 'b')
        self.bn_gamma1 = self.get_bn_var('br_bn' + str(1) + 'm')
        self.bn_moments1 = self.get_bn_var('br_bn' + str(1) + 'x')
        self.bn_beta2 = self.get_bn_var('br_bn' + str(2) + 'b')
        self.bn_gamma2 = self.get_bn_var('br_bn' + str(2) + 'm')
        self.bn_moments2 = self.get_bn_var('br_bn' + str(2) + 'x')
        self.bn_beta3 = self.get_bn_var('br_bn' + str(3) + 'b')
        self.bn_gamma3 = self.get_bn_var('br_bn' + str(3) + 'm')
        self.bn_moments3 = self.get_bn_var('br_bn' + str(3) + 'x')
        self.bn_beta4 = self.get_bn_var('br_bn' + str(4) + 'b')
        self.bn_gamma4 = self.get_bn_var('br_bn' + str(4) + 'm')
        self.bn_moments4 = self.get_bn_var('br_bn' + str(4) + 'x')
        self.bn_beta5 = torch.from_numpy(self.params_values_list[23]).cuda()
        self.bn_gamma5 = torch.from_numpy(self.params_values_list[22]).cuda()
        self.bn_moments5 = torch.from_numpy(np.squeeze(self.params_values_list[24])).cuda()
        self.cf = nn.Conv2d(32, 1, kernel_size=(17, 17),
                                                        stride=1, padding=2)
        self.init_weight()

    def get_bn_var(self, name):
        # temp = 'br_'+name
        if self.params_names_list is not None and name in self.params_names_list:
            # ind = self.params_names_list.index[name]
            idx = [i for i, x in enumerate(self.params_names_list) if name in x]
            idx = idx[0]
            value = torch.from_numpy(np.squeeze(self.params_values_list[idx])).cuda()
        return value

    def init_weight(self):
        self.conv1.weight.data = torch.from_numpy(np.transpose(self.params_values_list[0], [3, 2, 0, 1]))
        self.conv2.weight.data = torch.from_numpy(np.transpose(self.params_values_list[5], [3, 2, 0, 1]))
        self.conv3.weight.data = torch.from_numpy(np.transpose(self.params_values_list[10], [3, 2, 0, 1]))
        self.conv4.weight.data = torch.from_numpy(np.transpose(self.params_values_list[15], [3, 2, 0, 1]))
        self.conv5.weight.data = torch.from_numpy(np.transpose(self.params_values_list[20], [3, 2, 0, 1]))
        self.conv1.bias.data = torch.from_numpy(np.squeeze(self.params_values_list[1]))
        self.conv2.bias.data = torch.from_numpy(np.reshape(self.params_values_list[6],[1,256,1,1]))
        self.conv3.bias.data = torch.from_numpy(np.squeeze(self.params_values_list[11]))
        self.conv4.bias.data = torch.from_numpy(np.reshape(self.params_values_list[16],[1,384,1,1]))
        self.conv5.bias.data = torch.from_numpy(np.reshape(self.params_values_list[21],[1,32,1,1]))
        self.bn1.weight.data = self.bn_gamma1
        self.bn1.bias.data = self.bn_beta1
        self.bn1.running_mean = self.bn_moments1[:,0]/1.
        self.bn1.running_var = self.bn_moments1[:, 1]**2/1.
        self.bn1.eps=0.001
        self.bn1.momentum = 0.99

        self.bn2.weight.data = self.bn_gamma2
        self.bn2.bias.data = self.bn_beta2
        self.bn2.running_mean = self.bn_moments2[:, 0]/1.
        self.bn2.running_var = self.bn_moments2[:, 1]**2/1.
        self.bn2.eps = 0.001
        self.bn2.momentum = 0.99

        self.bn3.weight.data = self.bn_gamma3
        self.bn3.bias.data = self.bn_beta3
        self.bn3.running_mean = self.bn_moments3[:, 0]/1.
        self.bn3.running_var = self.bn_moments3[:, 1]**2 /1.
        self.bn3.eps = 0.001
        self.bn3.momentum = 0.99

        self.bn4.weight.data = self.bn_gamma4
        self.bn4.bias.data = self.bn_beta4
        self.bn4.running_mean = self.bn_moments4[:, 0]/1.
        self.bn4.running_var = self.bn_moments4[:, 1]**2 /1.
        self.bn4.eps = 0.001
        self.bn4.momentum = 0.99

        self.bn5.weight.data = self.bn_gamma5
        self.bn5.bias.data = self.bn_beta5
        self.bn5.running_mean = torch.from_numpy(np.array([self.bn_moments5[0]])).float().cuda()/1.
        self.bn5.running_var = torch.from_numpy(np.array([self.bn_moments5[1]])).float().cuda() ** 2/1.
        self.bn5.eps = 0.001
        self.bn5.momentum = 0.99

        self.cf.bias.data.zero_()
        self.cf.weight.data = (self.cf.weight.data.normal_() / np.sqrt(32 * 2 * 2)) / 1e5

    def _import_from_matconvnet(self, net_path):
        mat = scipy.io.loadmat(net_path)
        net_dot_mat = mat.get('net')
        params = net_dot_mat['params']
        params = params[0][0]
        params_names = params['name'][0]
        params_names_list = [params_names[p][0] for p in range(params_names.size)]
        params_values = params['value'][0]
        params_values_list = [params_values[p] for p in range(params_values.size)]
        return params_names_list, params_values_list

    def forward(self, x):
        x = self.conv1(x)
        x = self.bn1(x)
        x = self.relu1(x)
        # x = self.pad1(x)
        x = self.pool1(x)

        conv2_1 = self.conv2.weight[0:128,:,:,:]
        conv2_2 = self.conv2.weight[128:,:,:,:]
        x1 = x[:, :48, :, :]
        x2 = x[:, 48:, :, :]
        x2_1 = conv2d_p1(x1, conv2_1, padding=0)
        x2_2 = conv2d_p1(x2, conv2_2, padding=0)
        x = torch.cat([x2_1,x2_2],dim=1)+self.conv2.bias
        x = self.bn2(x)
        x = self.relu2(x)
        # x = self.pad2(x)
        x = self.pool2(x)

        x = self.conv3(x)
        x = self.bn3(x)
        x = self.relu3(x)

        conv4_1 = self.conv4.weight[0:192, :, :, :]
        conv4_2 = self.conv4.weight[192:, :, :, :]
        x1 = x[:,:192,:,:]
        x2 = x[:,192:,:,:]
        x4_1 = conv2d(x1, conv4_1,padding=0)
        x4_2 = conv2d(x2, conv4_2,padding=0)
        x = torch.cat([x4_1, x4_2], dim=1) + self.conv4.bias
        x = self.bn4(x)
        x = self.relu4(x)
        #
        conv5_1 = self.conv5.weight[0:16, :, :, :]
        conv5_2 = self.conv5.weight[16:, :, :, :]
        x1 = x[:, :192, :, :]
        x2 = x[:, 192:, :, :]
        x5_1 = conv2d(x1, conv5_1,padding=0)
        x5_2 = conv2d(x2, conv5_2,padding=0)
        x = torch.cat([x5_1, x5_2], dim=1) + self.conv5.bias
        # x = self.bn55(x)
        # # x = self.relu1(x)
        return x

    def siam(self, s, b):
        score_ = []
        for i in range(3):
            score = conv2d(s[i,:,:,:].unsqueeze(0), b, stride=1, padding=0)
            score = self.bn5(score)
            # score = bilinear_upsample(score,(score_sz2,score_sz2))
            score_.append(score)
        score_ = torch.stack(score_,0).squeeze()
        return score_

    def siam_train(self,x):
        return self.cf(x)

    def forward_res(self, res):
        return self.bn5(res)

    def load_model(self, model_path):
        states = torch.load(model_path)
        features = states['features']
        fc = states['fc']
        self.features.load_state_dict(features)
        self.fc.load_state_dict(fc)

    def load_mat_model(self, matfile):
        from_indices = [0, 2, 5, 7, 10, 12, 14, 17, 19, 21]
        to_indices = [0, 2, 6, 8, 12, 14, 16, 18, 20, 22]
        mat = scipy.io.loadmat(matfile)
        mat_features = list(mat['layers'])[0]
        # copy conv weights
        for i in range(len(from_indices)):
            from_i = from_indices[i]
            to_i = to_indices[i]
            weight, bias = mat_features[from_i]['weights'].item()[0]
            self.features[to_i].weight.data = torch.from_numpy(np.transpose(weight, (3, 2, 0, 1)))
            self.features[to_i].bias.data = torch.from_numpy(bias[:, 0])


class L2normLoss(nn.Module):
    def __init__(self):
        super(L2normLoss, self).__init__()

    def forward(self, X, C):
        # maskk=None
        abs_diff = (X - C).abs()
        mask = (abs_diff >= 0.1).float()
        n_effect = mask.sum() + 1
        loss = (C.exp() * mask * (X - C)).pow(2).sum() / n_effect
        return loss